=== modified file 'src/com/goldencode/p2j/ui/client/gui/TreeGuiImpl.java'
--- src/com/goldencode/p2j/ui/client/gui/TreeGuiImpl.java	2021-06-09 13:50:54 +0000
+++ src/com/goldencode/p2j/ui/client/gui/TreeGuiImpl.java	2021-06-17 18:05:43 +0000
@@ -92,27 +92,28 @@
 */
 package com.goldencode.p2j.ui.client.gui;
 
+import java.util.*;
+import java.util.function.*;
+
+import org.apache.commons.collections.iterators.*;
+
 import com.goldencode.p2j.ui.*;
 import com.goldencode.p2j.ui.TreeNodeEntry.*;
 import com.goldencode.p2j.ui.chui.*;
 import com.goldencode.p2j.ui.client.*;
 import com.goldencode.p2j.ui.client.border.*;
-import com.goldencode.p2j.ui.client.driver.*;
 import com.goldencode.p2j.ui.client.event.*;
 import com.goldencode.p2j.ui.client.event.listener.*;
-import com.goldencode.p2j.ui.client.gui.GuiFontResolver.FontCache;
+import com.goldencode.p2j.ui.client.gui.GuiFontResolver.*;
 import com.goldencode.p2j.ui.client.gui.driver.*;
-import com.goldencode.p2j.ui.client.gui.theme.Theme;
-import com.goldencode.p2j.ui.client.gui.theme.ThemeManager;
-import com.goldencode.p2j.ui.client.layout.BorderLayout;
+import com.goldencode.p2j.ui.client.gui.theme.*;
+import com.goldencode.p2j.ui.client.layout.*;
+import com.goldencode.p2j.ui.client.model.*;
 import com.goldencode.p2j.ui.client.widget.*;
 import com.goldencode.p2j.util.*;
-
-import org.apache.commons.collections.iterators.*;
-
-import java.util.*;
-import java.util.function.*;
-
+import com.goldencode.util.*;
+import com.google.common.base.MoreObjects.*;
+import com.google.common.collect.*;
 
 /**
  * Base class for client-side implementations of TREEVIEW and TREELIST widgets.
@@ -123,19 +124,16 @@
  * @param <N>
  *        node type 
  */
-public abstract class TreeGuiImpl<
-            C extends TreeConfig<N>,
-            B extends TreeBodyGuiImpl<C, ? extends TreeGuiImpl<C,B,N>, N>,
-            N extends TreeNodeEntry>
+public abstract class TreeGuiImpl
 extends BorderedPanelGuiImpl
-implements WidgetWithConfig<C>,
+implements WidgetWithConfig<TreeConfig>,
            DataContainer
 {
    /** Associated config instance */
-   protected C config;
+   protected TreeConfig config;
 
    /** Screen driver */
-   protected GuiDriver<?,?> gd;
+   protected final GuiDriver<?,?> gd = (GuiDriver<?,?>) OutputManager.getDriver();
 
    /** Font resolver */
    protected GuiFontResolver gf;
@@ -143,39 +141,47 @@
    /** Color resolver */
    protected GuiColorResolver gc;
 
-   /** ScrollPane which wraps the tree items and implements scrolling. */
-   protected ScrollPane<GuiOutputManager> scrollpane;
+   /**
+    * The scrolling provider.
+    */
+   protected GenericContainer scrollableContainer;
 
    /** Tree view body. */
-   protected B body = null;
+   public TreeBodyGuiImpl body = null;
 
    /** Currently selected node */
-   protected TreeNode<N> currentNode;
+   protected TreeNode currentNode;
 
    /** Current drop highlight node */
-   protected TreeNode<N> dropHighlightNode;
+   protected TreeNode dropHighlightNode;
 
    /** The root node */
-   protected TreeNode<N> rootNode;
+   protected TreeNode rootNode;
 
    /** Widget id */
    private WidgetId id;
 
    /** Map of node ids to nodes */
-   private HashMap<Integer, TreeNode<N>> idNodes;
+   private HashMap<Integer, TreeNode> idNodes;
 
    /** The tree label editor */
-   public TreeEditor<?, C> treeEditor;
-
+   public TreeEditor treeEditor;
+
+   /** Horizontal scroll model */
+   final ScrollModel hModel = new ScrollModel();
+
+   /** Horizontal scroll model */
+   final ScrollModel vModel = new ScrollModel();
+   
    /**
-    * Construtor.
+    * Constructor.
     * 
     * @param   id
     *          Widget id.
     * @param   cfg
     *          Config instance.
     */
-   public TreeGuiImpl(WidgetId id, C cfg)
+   public TreeGuiImpl(final WidgetId id, final TreeConfig cfg)
    {
       this.id = id;
       this.config = cfg;
@@ -193,43 +199,28 @@
     *          Config instance.
     */
    @Override
-   public void initialize(WidgetId id, C cfg)
+   public void initialize(final WidgetId id, final TreeConfig cfg)
    {
       config = ConfigManager.getInstance().resolveWidgetConfig(id, cfg);
 
-      // screen driver
-      if (gd == null)
-      {
-         gd = (GuiDriver<?,?>) OutputManager.getDriver();
-      }
-      // and font resolver
-      if (gf == null)
-      {
-         gf = new GuiFontResolver(WindowManager.resolveWindow(this), gd, config, false);
-      }
+      gf = new GuiFontResolver(WindowManager.resolveWindow(this), gd, config, false);
 
-      int bgColor = isThreeD() && !config.enabled ? SysColor.COLOR_3DFACE : SysColor.COLOR_WINDOW;
+      final int bgColor = isThreeD() && !config.enabled ? SysColor.COLOR_3DFACE : SysColor.COLOR_WINDOW;
       
       gc = new GuiColorResolver(gd, config, bgColor, SysColor.COLOR_BTNTEXT);
       
+      // FIXME: is this correct?
       setBorder(new LineBorderGuiImpl(null, gc, null));
 
-      WidgetFactory<GuiOutputManager> factory = screen().getFactory();
-
+      final WidgetRegistry<GuiOutputManager> registry = screen().getRegistry();
       body = createBody();
-      
-      scrollpane = factory.createScrollPane(body);
-      scrollpane.getRootPanel().setTransparent(true);
-      scrollpane.setScrollBars(ScrollBar.Bars.BOTH);
-
-      add(scrollpane);
-
-      WidgetRegistry<GuiOutputManager> registry = screen().getRegistry();
-      
-      registry.addWidget(scrollpane);
       registry.addWidget(body);
-      
-      treeEditor = new TreeEditor<>(gd, screen(), screen().coordinates(), this, null, null, gc, gf);
+
+      scrollableContainer = new ScrollableContainer(body, hModel, vModel);
+      add(scrollableContainer);      
+      registry.addWidget(scrollableContainer);
+
+      treeEditor = new TreeEditor(gd, screen(), screen().coordinates(), this, null, null, gc, gf);
       add(treeEditor);
    }
 
@@ -254,7 +245,7 @@
     * @return  Reference to widget config.
     */
    @Override
-   public C config()
+   public TreeConfig config()
    {
       return config;
    }
@@ -276,69 +267,61 @@
     *          Config reference capturing the config state before the owner's config was modified.
     */
    @Override
-   public void afterConfigUpdate(C beforeUpdate)
+   public void afterConfigUpdate(TreeConfig beforeUpdate)
    {
       super.afterConfigUpdateBase(beforeUpdate);
 
-      if (body != null)
-      {
-         Integer topNodeId = null;
-         
-         if (config.topNode != beforeUpdate.topNode && config.topNode > 0)
-         {
-            topNodeId = config.topNode;
-         }
-         // the color values can be changed even if the assignFlags is the same
-         if (config.selectedNodeBg != beforeUpdate.selectedNodeBg ||
-             config.selectedNodeFg != beforeUpdate.selectedNodeFg)
-         {
-            body.updateColors(config);
-         }
-         
-         buildTreeModel();
-         
-         if (topNodeId != null)
-         {
-            TreeGuiImpl.TreeNode<N>  topNode = findNode(topNodeId);
-            toggleNodeExpansion(topNode, true);
-            body.scrollToTop(topNodeId);
-         }
-         
-         if (isLabelsEditingSupported() && idNodes.containsKey(config.selectedNodeId))
-         {
-            TreeNode<N> selectedNode = idNodes.get(config.selectedNodeId);
-            
-            if (selectedNode.value.editorMode == EditorMode.ACTIVATING)
-            {
-               //config.nodes.indexOf(selectedNode.value) != -1
-               //selectedNode.value is a reference to some node entry
-               if (fireBeforeLabelEdit(selectedNode))
-               {
-                  selectedNode.value.editorMode = EditorMode.INACTIVE;
-                  treeEditor.deactivateEditor();
-               }
-               else
-               {
-                  selectedNode.value.editorMode = EditorMode.ACTIVE;
-                  
-                  getBody().ensureVisible(selectedNode, false, false);
-                  
-                  NativeRectangle labelBounds = getNodeLabelBounds(selectedNode);
-                  
-                  treeEditor.activateEditor(labelBounds.left(),
-                                            labelBounds.top(),
-                                            labelBounds.width(),
-                                            labelBounds.height(),
-                                            (String) selectedNode.value.getValue(0));
-                  treeEditor.requestFocus(true);
-               }
-               
-               ConfigHelper.setModified(config, true);
-            }
-         }
-         
-         repaint();
-      }
+      final Integer topNodeId = (config.topNode != beforeUpdate.topNode && config.topNode > 0)
+               ? config.topNode
+               : null;
+      // the color values can be changed even if the assignFlags is the same
+      if (config.selectedNodeBg != beforeUpdate.selectedNodeBg
+               || config.selectedNodeFg != beforeUpdate.selectedNodeFg)
+      {
+         body.updateColors(config);
+      }
+
+      buildTreeModel();
+
+      if (topNodeId != null)
+      {
+         final TreeNode topNode = findNode(topNodeId);
+         toggleNodeExpansion(topNode, true);
+         body.scrollToTop(topNodeId);
+      }
+
+      if (isLabelsEditingSupported() && idNodes.containsKey(config.selectedNodeId))
+      {
+         final TreeNode selectedNode = idNodes.get(config.selectedNodeId);
+
+         if (selectedNode.value.editorMode == EditorMode.ACTIVATING)
+         {
+            // config.nodes.indexOf(selectedNode.value) != -1
+            // selectedNode.value is a reference to some node entry
+            if (fireBeforeLabelEdit(selectedNode))
+            {
+               selectedNode.value.editorMode = EditorMode.INACTIVE;
+               treeEditor.deactivateEditor();
+            }
+            else
+            {
+               selectedNode.value.editorMode = EditorMode.ACTIVE;
+
+               getBody().ensureVisible(selectedNode, false, false);
+
+               NativeRectangle labelBounds = getNodeLabelBounds(selectedNode);
+
+               treeEditor.activateEditor(labelBounds.left(), labelBounds.top(),
+                        labelBounds.width(), labelBounds.height(),
+                        (String) selectedNode.value.getValue(0));
+               treeEditor.requestFocus(true);
+            }
+
+            ConfigHelper.setModified(config, true);
+         }
+      }
+
+      repaint();
    }
 
    /**
@@ -349,9 +332,9 @@
     * 
     * @return   The node label's bounds
     */
-   public NativeRectangle getNodeLabelBounds(TreeNode<?> node)
+   public NativeRectangle getNodeLabelBounds(final TreeNode node)
    {
-      int level = getNodeLevel(node);
+      int level = node.getLevel();
       
       int rowIndex = getNodeRowIndex(node);
       
@@ -387,7 +370,7 @@
     * 
     * @return   True if the trigger code returns NO-APPLY, otherwise false.
     */
-   public boolean fireBeforeLabelEdit(TreeGuiImpl.TreeNode<?> node)
+   public boolean fireBeforeLabelEdit(final TreeNode node)
    {
       config().triggerNode = node.value.nodeId;
       
@@ -408,7 +391,7 @@
     * 
     * @return   True if the trigger code returns NO-APPLY, otherwise false.
     */
-   public boolean fireAfterLabelEdit(TreeGuiImpl.TreeNode<?> node, String newLabel)
+   public boolean fireAfterLabelEdit(final TreeNode node, final String newLabel)
    {
       config().triggerNode = node.value.nodeId;
       config().newLabel = newLabel;
@@ -440,7 +423,7 @@
    @Override
    public void setValue(BaseDataType value)
    {
-      TreeNode<N> node = null;
+      TreeNode node = null;
       if (value != null && !value.isUnknown())
       {
          node = findFirstNodeWithText(value.toStringMessage());
@@ -565,7 +548,7 @@
     *
     * @return  see above.
     */
-   public TreeNode<N> getCurrentNode()
+   public TreeNode getCurrentNode()
    {
       return currentNode;
    }
@@ -575,7 +558,7 @@
     *
     * @return   The drop highlight node.
     */
-   public TreeNode<N> getDropHighlightNode()
+   public TreeNode getDropHighlightNode()
    {
       return dropHighlightNode;
    }
@@ -585,7 +568,7 @@
     *
     * @return  see above.
     */
-   public TreeNode<N> getRootNode()
+   public TreeNode getRootNode()
    {
       return rootNode;
    }
@@ -595,7 +578,7 @@
     *
     * @return  see above.
     */
-   public B getBody()
+   public TreeBodyGuiImpl getBody()
    {
       return body;
    }
@@ -669,7 +652,7 @@
     * 
     * @return   The tree node editor
     */
-   public TreeEditor<?, C> getTreeEditor()
+   public TreeEditor getTreeEditor()
    {
       return treeEditor;
    }
@@ -684,7 +667,7 @@
     * 
     * @return   The image
     */
-   public final ImageWrapper<?> getNodeImage(final TreeNode<?> node, final boolean nodeSelected)
+   public final ImageWrapper<?> getNodeImage(final TreeNode node, final boolean nodeSelected)
    {
       final int imgId = node.getNodeImageId(nodeSelected);
       if (imgId < 0)
@@ -733,7 +716,7 @@
     *
     * @return  the node text.
     */
-   protected abstract String getNodeText(TreeNode<N> node);
+   protected abstract String getNodeText(final TreeNode node);
 
 
    /**
@@ -742,7 +725,7 @@
     * @param   nodes
     *          List of nodes.
     */
-   protected abstract void sortNodes(List<? extends N> nodes);
+   protected abstract void sortNodes(final List<TreeNodeEntry> nodes);
 
    /**
     * Updates a tree node with the backing configuration entry.
@@ -752,7 +735,7 @@
     * @param   nodeEntry
     *          Configuration entry.
     */
-   protected void updateTreeNode(TreeNode<N> node, N nodeEntry)
+   protected static void updateTreeNode(final TreeNode node, final TreeNodeEntry nodeEntry)
    {
       node.value = nodeEntry;
    }
@@ -762,14 +745,14 @@
     *
     * @return  valid body instance.
     */
-   protected abstract B createBody();
+   protected abstract TreeBodyGuiImpl createBody();
 
    /**
     * Builds tree model from the config's flat list.
     */
    protected void buildTreeModel()
    {
-      final C c = config();
+      final TreeConfig c = config();
       if (c.selectedNodeId <= 0)
       {
          final TreeNodeEntry selected = currentNode != null ? currentNode.value : null;
@@ -785,19 +768,18 @@
       }
       
       idNodes = new HashMap<>();
-      final TreeNode<N> root = new TreeNode<>();
+      final TreeNode root = new TreeNode();
 
+      final List<TreeNodeEntry> nodes = c.nodes;
       if (c.sorted)
       {
-         sortNodes(c.nodes);
+         sortNodes(nodes);
       }
 
-      for (int i = 0; i < c.nodes.size(); i++)
+      for (final TreeNodeEntry n : nodes)
       {
-         final N n = c.nodes.get(i);
-         final TreeNode<N> node = new TreeNode<>();
+         final TreeNode node = new TreeNode();
          updateTreeNode(node, n);
-
          idNodes.put(n.nodeId, node);
 
          // restore selection
@@ -812,10 +794,9 @@
          }
      }
 
-      for (int i = 0; i < c.nodes.size(); i++)
+      for (final TreeNodeEntry n : nodes)
       {
-         final N n = c.nodes.get(i);
-         final TreeNode<N> node = idNodes.get(n.nodeId);
+         final TreeNode node = idNodes.get(n.nodeId);
          final int parentId = n.parentId;
          if (parentId != Integer.MIN_VALUE)
          {
@@ -838,6 +819,8 @@
 
       rootNode = root;
       body.calcSize();
+      body.updateVScrollModel();
+      body.updateHScrollModel();
       repaint();
    }
 
@@ -872,12 +855,12 @@
     *
     * @return  a tree node instance or null if no node found.
     */
-   TreeNode<N> findFirstNodeWithText(String nodeText)
+   TreeNode findFirstNodeWithText(String nodeText)
    {
-      NodesIterator<N> it = new NodesIterator<N>(rootNode, false);
+      final NodesIterator it = new NodesIterator(rootNode, false);
       while (it.hasNext())
       {
-         TreeNode<N> node = it.next();
+         TreeNode node = it.next();
          if (getNodeText(node).equalsIgnoreCase(nodeText))
          {
             return node;
@@ -893,7 +876,7 @@
     * @param   node
     *          The node to set as current.
     */
-   public void setCurrentNode(final TreeNode<N> node)
+   public void setCurrentNode(final TreeNode node)
    {
       setCurrentNode(node, true, true);
    }
@@ -908,7 +891,7 @@
     * @param   direct
     *          If {@code true}, the method will post the input event {@link Keyboard#SE_CHANGE_NODE_DIRECT}.
     */
-   public void setCurrentNode(final TreeNode<N> node, boolean trigger, boolean direct)
+   public void setCurrentNode(final TreeNode node, boolean trigger, boolean direct)
    {
       if (currentNode == node)
       {
@@ -917,7 +900,7 @@
 
       getTreeEditor().deactivateEditor();
 
-      final C c = config();
+      final TreeConfig c = config();
       final int prevNode = c.selectedNodeId;
 
       if (node == null)
@@ -929,7 +912,7 @@
       else
       {
 
-         TreeNode<N> parent = node.parent;
+         TreeNode parent = node.parent;
          while (parent != null && parent.value != null)
          {
             parent.value.expanded = true;
@@ -967,7 +950,7 @@
     *
     * @return  the index.
     */
-   int getNodeRowIndex(TreeNode<?> node)
+   int getNodeRowIndex(final TreeNode node)
    {
       return getNodeRowIndex(node, true);
    }
@@ -984,10 +967,10 @@
     * 
     * @return  the index.
     */
-   int getNodeRowIndex(TreeNode<?> node, boolean excludeCollapsedNodes)
+   int getNodeRowIndex(final TreeNode node, final boolean excludeCollapsedNodes)
    {
       int res = 0;
-      NodesIterator<?> it = new NodesIterator<>(rootNode, excludeCollapsedNodes);
+      NodesIterator it = new NodesIterator(rootNode, excludeCollapsedNodes);
       while (it.hasNext())
       {
          if (it.next() == node)
@@ -1013,10 +996,10 @@
     * 
     * @return  the index.
     */
-   int getNodeRowIndex(int nodeId, boolean excludeCollapsedNodes)
+   int getNodeRowIndex(final int nodeId, final boolean excludeCollapsedNodes)
    {
       int res = 0;
-      NodesIterator<?> it = new NodesIterator<>(rootNode, excludeCollapsedNodes);
+      final NodesIterator it = new NodesIterator(rootNode, excludeCollapsedNodes);
       while (it.hasNext())
       {
          if (it.next().value.nodeId == nodeId)
@@ -1038,33 +1021,12 @@
     *
     * @return  {@link TreeNode} or {@code null} when no node found.
     */
-   TreeNode<N> findNode(int nodeId)
+   TreeNode findNode(final int nodeId)
    {
       return idNodes.get(nodeId);
    }
 
    /**
-    * Returns the zero based node level.
-    *
-    * @param   node
-    *          The level to test.
-    *
-    * @return  the node level.
-    */
-   int getNodeLevel(TreeNode<?> node)
-   {
-      int result = -1;
-      TreeNode<?> parent = node.parent;
-      while (parent != null)
-      {
-         result++;
-         parent = parent.parent;
-      }
-
-      return result;
-   }
-
-   /**
     * Returns {@code true} if the tree has at least one node.
     *
     * @return  see above.
@@ -1079,7 +1041,7 @@
     */
    void toggleCurrentNodeExpansion()
    {
-      final TreeGuiImpl.TreeNode<?> currentNode = getCurrentNode();
+      final TreeNode currentNode = getCurrentNode();
       if (currentNode != null)
       {
          toggleNodeExpansion(currentNode);
@@ -1092,7 +1054,7 @@
     * @param   node
     *          The node to expand or collapse.
     */
-   void toggleNodeExpansion(TreeNode<?> node)
+   void toggleNodeExpansion(final TreeNode node)
    {
       if (node == null)
       {
@@ -1110,7 +1072,7 @@
     * @param   expand
     *          The desired expansion state.
     */
-   protected void toggleNodeExpansion(final TreeNode<?> node, final boolean expand)
+   protected void toggleNodeExpansion(final TreeNode node, final boolean expand)
    {
       // We have no means to call root node expand/collapse, so we are assuming the node is not
       // the root node
@@ -1120,7 +1082,7 @@
          return;
       }
 
-      final C c = config();
+      final TreeConfig c = config();
       final int nodeId = value.nodeId;
       c.triggerNode = nodeId;
 
@@ -1136,7 +1098,7 @@
       }
 
       // the nodes may have been rebuilt, retrieve the node from the model again
-      TreeNode<N> n = findNode(nodeId);
+      TreeNode n = findNode(nodeId);
       if (n == null)
       {
          return;
@@ -1145,7 +1107,7 @@
       // The node cannot be root, so there is no need to test the value for nullness
       if (expand)
       {
-         /** Make sure all ancestors are expanded too */
+         // Make sure all ancestors are expanded too
          while (n != null && n.value != null)
          {
             n.value.expanded = true;
@@ -1163,7 +1125,8 @@
       fireNodeExpansionTrigger(c,
                expand ? Keyboard.SE_NODE_EXPANDED : Keyboard.SE_NODE_COLLAPSED);
 
-      body.calcSize();
+      // body.calcSize();
+      body.updateHScrollModel();
       repaint();
    }
 
@@ -1173,7 +1136,7 @@
     * @param   cfgTree
     *          The tree widget config.
     */
-   protected void makeNodeConfigDirty(C cfgTree)
+   protected static void makeNodeConfigDirty(final TreeConfig cfgTree)
    {
       ConfigManager.getInstance().addDirtyConfig(cfgTree, "nodes");
    }
@@ -1184,19 +1147,21 @@
     * 
     * @return   Boolean value that indicates label's editing is supported or not.
     */
+   @SuppressWarnings("static-method")
    protected boolean isLabelsEditingSupported()
    {
       return false;
    }
 
    /**
-    * Returns the number of visible nodes that will fully fit in the widget's viewport.
+    * Returns the number of visible nodes that will at least partly fit in the widget's viewport.
     *
     * @return  see above.
     */
    int getVisibleNodeCount()
    {
-      return scrollpane.viewport().physicalDimension().height / body.getNodeHeight();
+      final int nodeHeight = body.getNodeHeight();
+      return (body.physicalDimension().height + nodeHeight - 1) / nodeHeight;
    }
 
    /**
@@ -1219,7 +1184,7 @@
     *
     * @return  <code>TRUE</code> if trigger result consumed, <code>FALSE</code> otherwise.
     */
-   protected boolean fireNodeExpansionTrigger(C cfgTree, int eventCode)
+   protected boolean fireNodeExpansionTrigger(TreeConfig cfgTree, int eventCode)
    {
       makeNodeConfigDirty(cfgTree);
       
@@ -1235,16 +1200,17 @@
     * @param <N> 
     *        node type
     */
-   public static class TreeNode<N extends TreeNodeEntry>
+   public static class TreeNode
+   extends AbstractPrintable
    {
       /** Parent node */
-      public TreeNode<N> parent;
+      public TreeNode parent;
 
       /** Child nodes or {@code null} if case of no children */
-      public ArrayList<TreeNode<N>> nodes;
+      public List<TreeNode> nodes;
 
       /** Related config node entry */
-      public N value;
+      public TreeNodeEntry value;
 
       /**
        * Adds a node to the list of child nodes.
@@ -1253,7 +1219,7 @@
        * @param   node
        *          The node to add.
        */
-      public void addNode(TreeNode<N> node)
+      public void addNode(TreeNode node)
       {
          if (nodes == null)
          {
@@ -1293,11 +1259,175 @@
        *        
        * @return see above
        */
-      public boolean isDescendantOf(final TreeNode<N> other)
+      public boolean isDescendantOf(final TreeNode other)
       {
          return parent == other || (parent != null && parent.isDescendantOf(other));
       }
 
+      public int childIndex()
+      {
+         return parent.nodes.indexOf(this);
+      }
+      
+      /**
+       * Get list consisting of this node and of ancestors of this node, starting from the tree root.
+       * 
+       * @return see above
+       */
+      private final List<TreeNode> ancestorsAndThis()
+      {
+         if(parent == null)
+         {
+            return Lists.newArrayList(this);
+         }
+         final List<TreeNode> result = parent.ancestorsAndThis();
+         result.add(this);
+         return result;
+      }
+
+      /**
+       * Test if this node is strictly lower than other sibling node in sibling order.
+       *  
+       * @param other
+       *        other node to compare, must be a sibling to this node, and differ from this node
+       *        
+       * @return see above
+       */
+      private final boolean isSiblingLowerThan(final TreeNode other)
+      {
+         assert parent != null;
+         assert other.parent == parent;
+         final List<TreeNode> siblings = parent.nodes;
+         for (TreeNode n : siblings)
+         {
+            if (n == this)
+            {
+               return true;
+            }
+            if (n == other)
+            {
+               return false;
+            }
+         }
+         throw new IllegalStateException();
+      }
+      
+      /**
+       * Test if this node precedes a given node in tree depth first traversal order.
+       * 
+       * Both nodes must not be null, the same node, or tree root.
+       * 
+       * @param other
+       *        the node to compare with
+       *        
+       * @return see above.
+       */
+      public boolean isDFTBeforeThan(final TreeNode other)
+      {
+         assert other != null;
+         assert this != other;
+         assert parent != null;
+         assert other.parent != null;
+
+         final List<TreeNode> thisAncestors = ancestorsAndThis();
+         final List<TreeNode> otherAncestors = other.ancestorsAndThis();
+         final int thisAncestorsSize = thisAncestors.size();
+         final int minLength = Math.min(thisAncestorsSize, otherAncestors.size());
+
+         // Nodes belong to the same tree, so have at least common ancestor,
+         // and both list lengths are at least 2.
+         for (int lcoIdx = 1;; lcoIdx++)
+         {
+            TreeNode n = thisAncestors.get(lcoIdx);
+            TreeNode o = otherAncestors.get(lcoIdx);
+            if (n != o)
+            {
+               return n.isSiblingLowerThan(o);
+            }
+            if (lcoIdx == minLength - 1)
+            {
+               if (thisAncestorsSize > minLength)
+               {
+                  final TreeNode n2 = thisAncestors.get(minLength -1);
+                  if (n2 == other)
+                  {
+                     // this node descends from the other
+                     return false;
+                  }
+                  return !other.isSiblingLowerThan(n2);
+               }
+               final TreeNode o2 = otherAncestors.get(minLength -1);
+               if (o2 == this)
+               {
+                  // other node descends from this node
+                  return true;
+               }
+               return this.isSiblingLowerThan(o2);
+            }
+         }
+      }
+
+      /**
+       * Returns the zero based node level.
+       * The level of the root (invisible) node is -1.
+       *
+       * @return  the node level.
+       */
+      public int getLevel()
+      {
+         return parent != null ? parent.getLevel() + 1 : -1;
+      }
+
+      /**
+       * Get the next sibling of this node or {@code null} if this node is the last child.
+       * 
+       * @return see above
+       */
+      public final TreeNode nextSibling()
+      {
+         if (parent == null)
+         {
+            // I am root, I have no siblings
+            return null;
+         }
+         
+         final List<TreeNode> meAndSiblings = parent.nodes;
+         assert meAndSiblings != null;
+         final int myIdx = meAndSiblings.indexOf(this);
+         assert myIdx >= 0; // otherwise the hierarchy is broken
+         return myIdx < meAndSiblings.size() - 1 ? meAndSiblings.get(myIdx + 1) : null;
+      }
+      
+      private TreeNode nextSiblingRecursively()
+      {
+         final TreeNode sibling = nextSibling();
+         return sibling != null ? sibling
+                  : parent == null ? null : parent.nextSiblingRecursively();
+      }
+      
+      /**
+       * Get the next visible node in the hierarchy
+       * 
+       * @return the next visible node or {@code null} if this node is the last visible node.
+       */
+      public TreeNode nextVisible()
+      {
+         if (parent == null)
+         {
+            // This node is the root node, which is never visible
+            return null;
+         }
+
+         if (value.expanded && nodes != null)
+         {
+            // This node is expanded, and there is at least one child, return it
+            return nodes.get(0);
+         }
+
+         final TreeNode nextSibling = nextSibling();
+         return nextSibling != null ? nextSibling : parent.nextSiblingRecursively();
+      }
+      
       /**
        * Return the internal image identifier.
        *  
@@ -1308,24 +1438,13 @@
        */
       public final int getNodeImageId(final boolean nodeSelected)
       {
+         if (nodeSelected && value.selectedIconId != -1)
+         {
+            return value.selectedIconId;
+         }
+
          // node image if defined
-         int imgId = value.expanded && value.expandIconId != -1 ?
-                     value.expandIconId :
-                     value.iconId;
-         
-         if(nodeSelected)
-         {
-            if (value.selectedIconId != -1)
-            {
-               imgId = value.selectedIconId;
-            }
-            else
-            {
-               imgId = value.iconId;
-            }
-         }
-         
-         return imgId;
+         return value.expanded && value.expandIconId != -1 ? value.expandIconId : value.iconId;
       }
 
       /**
@@ -1336,7 +1455,7 @@
        * 
        * @return  index node in the list or <code>-1</code> if not found in list.
        */
-      private int check(TreeNode<N> node)
+      private int check(TreeNode node)
       {
          for (int i=0;i < nodes.size(); i++)
          {
@@ -1348,16 +1467,36 @@
          
          return -1;
       }
+
+      /**
+       * Add class-specific fields to the helper.
+       * 
+       * @param stringHelper the string helper to update
+       */
+      @Override
+      protected void updateStringHelper(final ToStringHelper stringHelper)
+      {
+         stringHelper.add("level", getLevel());
+         if (nodes != null)
+         {
+            stringHelper.addValue(nodes.size() + " children");
+         }
+
+         if (value != null)
+         {
+            value.updateStringHelper(stringHelper);
+         }
+      }
    }
 
    /**
     * Recursive nodes iterator.
     */
-   protected static class NodesIterator<T extends TreeNodeEntry>
-   implements Iterator<TreeNode<T>>
+   public static class NodesIterator
+   implements Iterator<TreeNode>
    {
       /** stack of iterators of individual node levels */
-      private Stack<ListIterator<TreeNode<T>>> stack = new Stack<>();
+      private java.util.Stack<ListIterator<TreeNode>> stack = new java.util.Stack<>();
 
       /** whether the unexpanded nodes should be iterated, too */
       private boolean visibleOnly;
@@ -1371,7 +1510,7 @@
        * @param   root
        *          Where to start the iteration.
        */
-      public NodesIterator(TreeNode<T> root)
+      public NodesIterator(final TreeNode root)
       {
          this(root, true);
       }
@@ -1384,7 +1523,7 @@
        * @param   visibleOnly
        *          Whether the unexpanded nodes should be iterated, too.
        */
-      public NodesIterator(TreeNode<T> root, boolean visibleOnly)
+      public NodesIterator(TreeNode root, boolean visibleOnly)
       {
          this(root, visibleOnly, false);
       }
